/*
X607Demo.c: Demo program for X607

Compiler: BC++ 3.1
          Turbo C ++ 1.01(3.01) (free from http://community.borland.com/museum)
          
Compile mode: large

Project: X607.C
         ..\..\lib\7188el.lib
         ..\..\lib\XBoard\X607.lib

Hardware: 7188EX + X607

[June/20/2002] by David
[07/July/2005] by Liam

/****************************************************************/
/*  X607:   128K SRAM Battery BAckup (10 year)                  */
/****************************************************************/

/********************* M5M51008 **********************************
 * Funtion:   128K Byte SRAM (1k Block,one Block is 128 Byte)    *
 *                                                               *
 * Date:       2002/6/20                                         *
 * ControlPin: /OE ---> /RD                                      *
 *             /S1 ---> /CS                                      *
 *              S2 ---> DIO14                                    *
 *             /W ---> /WR                                       *
 *                                                               *
 *                        offset 0~127 bytes                     *
 *               0   1   2                  125 126 127 byte     *
 *             +---+---+---+---------------+---+---+---+         *
 * Block 0     |   |   |   |               |   |   |   |         *
 *             |---+---+---+-------------- +---+---+---+         *
 * Block 1     |   |   |   |               |   |   |   |         *
 *             +---+---+---+-------------- +---+---+---+         *
 *               :                                   :           *
 *               :                                   :           *
 *               :                                   :           *
 *               :                                   :           *
 *               :                                   :           *
 *             +---+---+---+---------------+---+---+---+         *
 * Block 1021  |   |   |   |               |   |   |   |         *
 *             |---+---+---+-------------- +---+---+---+         *
 * Block 1022  |   |   |   |               |   |   |   |         *
 *             |---+---+---+-------------- +---+---+---+         *
 * Block 1023  |   |   |   |               |   |   |   |         *
 *             |---+---+---+-------------- +---+---+---+         *
 * Block 1024  |   |   |   |               |   |   |   |         *
 *             +---+---+---+-------------- +---+---+---+         *
 *                                                               *
 * **************************************************************/

#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>
#include "..\..\lib\7188e.h"
#include "..\..\lib\Xboard\X607.h"

void main(void)
{
    uchar Wdata[100];
    uchar Rdata[100];
    int WData,RData,iRet,iAction,block,offset;
    int len,i,quit;
    unsigned addr=0;
    
    InitLib();
    X607_Init();
    
    Puts("\n\r");
    Puts("*******************************************\n\r");
    Puts("|     Demo program for 7188EX + X607      |\n\r");
    Puts("|                                         |\n\r");
    Puts("|        [28,June,2002] by DAVID          |\n\r");
    Puts("*******************************************\n\r");
    
    while(iAction!=5)
    {
        iAction=0;
        quit=0;
        
        Puts("\n\r");
        Puts("1) Use [Absolute address] method to test 1 byte of 128K SRAM\n\r");
        Puts("2) Use [Block ,Offset] method to test 1 byte of 128K SRAM\n\r");
        Puts("3) Use [Absolute address] method to test N byte of 128K SRAM\n\r");
        Puts("4) Use [Block ,Offset] method to test N byte of 128K SRAM\n\r");
        Puts("\n\r");
        Puts("5) Quits demo program\n\r\n\r");
        Puts("Choose an option and press [Enter]:");
        Scanf("%d", &iAction);
        Puts("\n\r");
       
        switch(iAction)
        {
            /************************************************************/
            /* Use [Absolute address] method to test 1 byte of 128K SRAM*/
            /************************************************************/
            case 1:
                X607_Init();
                Print("Please input a absolute addrss ( 0-65535 ) to write SRAM:");
                Scanf("%u",&addr);
                Print("Please input data( 0-255) to write SRAM:");
                Scanf("%d",&Wdata[0]);
                X607_WriteFn(addr,1,Wdata);
                X607_ReadFn(addr,1,Rdata);
                Print("\n\rAddr[%5u]: Write data = %3d ,Read data = %3d.",addr,Wdata[0],Rdata[0]);
            break;
            /**********************************************************/
            /* Use [Block ,Offset] method to test 1 byte of 128K SRAM */
            /**********************************************************/
            case 2:
                X607_Init();
                Print("Please select block ( 0-1023 ) to write SRAM:");
                Scanf("%d",&block);
                Print("Please select offset( 0-127 ) to write SRAM:");
                Scanf("%d",&offset);
                Print("Please input data( 0-255 ) to write SRAM:");
                Scanf("%d",&WData);
                X607_Write(block ,offset,WData);
                RData = X607_Read(block,offset);
                Print("\n\r[%4d,%3d]: Write data = %3d ,Read data = %3d.",block,offset,WData,RData);
            break;
            /************************************************************/
            /* Use [Absolute address] method to test N byte of 128K SRAM*/
            /************************************************************/
            case 3:
                X607_Init();
                Print("Please input a absolute addrss ( 0-65535 ) to write SRAM:");
                Scanf("%u",&addr);
                Print("Please input data( 0-255 ) to write SRAM:");
                Scanf("%d",Wdata);
                Print("Please input N(0-65535) byte to write SRAM:");
                Scanf("%d",&len);
                for(i=0;i<len;i++) Wdata[i]=Wdata[0];
                X607_WriteFn(addr,len,Wdata);
                X607_ReadFn(addr,len,Rdata);
                for(i=0;i<len;i++){
                    Print("\n\r Addr[%5u]: Write data = %3d ,Read data = %3d.",i+addr,Wdata[i],Rdata[i]);
                    if(Wdata[i]!=Rdata[i])
                        Getch();
                }
            break;
            /**********************************************************/
            /* Use [Block ,Offset] method to test N byte of 128K SRAM */
            /**********************************************************/
            case 4:
                X607_Init();
                Print("Please select block (0-1023) to write SRAM:");
                Scanf("%d",&block);
                Print("Please select offset(0-127) to write SRAM:");
                Scanf("%d",&offset);
                Print("Please input data(0-255) to write SRAM:");
                Scanf("%d",&WData);
                Print("Please input N(0-100) byte to write SRAM:");
                Scanf("%d",&len);
                for (i=0;i<len;i++){
                    X607_Write(block ,offset+i,WData);
                    RData = X607_Read(block,offset+i);
                    Print("\n\r[%4d,%3d]: Write data = %3d ,Read data = %3d.",block,offset+i,WData,RData);
                }
            break;
            
            case 5:
            default:
                quit=1;
            break;
        }
        if(!quit)
        {
            Puts("\n\rPress any key to continue...\n\r");
            Getch();
        }
    }
}


